#include <Adafruit_NeoPixel.h>

#define RIGHT 2
#define LEFT 3
#define NUMPIXELS 24

String key[26][2];
String input;

Adafruit_NeoPixel rightP(NUMPIXELS, RIGHT, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel leftP(NUMPIXELS, LEFT, NEO_GRB + NEO_KHZ800);

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  rightP.begin();
  leftP.begin();
  key[0][0] = "a";
  key[0][1] = ".-";
  key[1][0] = "b";
  key[1][1] = "-...";
  key[2][0] = "c";
  key[2][1] = "-.-.";
  key[3][0] = "d";
  key[3][1] = "-..";
  key[4][0] = "e";
  key[4][1] = ".";
  key[5][0] = "f";
  key[5][1] = "..-.";
  key[6][0] = "g";
  key[6][1] = "--.";
  key[7][0] = "h";
  key[7][1] = "....";
  key[8][0] = "i";
  key[8][1] = "..";
  key[9][0] = "j";
  key[9][1] = ".---";
  key[10][0] = "k";
  key[10][1] = "-.-";
  key[11][0] = "l";
  key[11][1] = ".-..";
  key[12][0] = "m";
  key[12][1] = "--";
  key[13][0] = "n";
  key[13][1] = "-.";
  key[14][0] = "o";
  key[14][1] = "---";
  key[15][0] = "p";
  key[15][1] = ".--.";
  key[16][0] = "q";
  key[16][1] = "--.-";
  key[17][0] = "r";
  key[17][1] = ".-.";
  key[18][0] = "s";
  key[18][1] = "...";
  key[19][0] = "t";
  key[19][1] = "-";
  key[20][0] = "u";
  key[20][1] = "..-";
  key[21][0] = "v";
  key[21][1] = "..-";
  key[22][0] = "w";
  key[22][1] = "...-";
  key[23][0] = "x";
  key[23][1] = "-..-";
  key[24][0] = "y";
  key[24][1] = "-.--";
  key[25][0] = "z";
  key[25][1] = "--..";
  
  Serial.println("Message: ");
}

void loop() {
  //uncomment one and comment the other two to use a function
  //morse();
  //lighting();
  rainbow();
  //normal();

} 

void dot(){
  rightP.setBrightness(80);
  leftP.setBrightness(80);
  for(int i=0; i<NUMPIXELS; i++) { 
    rightP.setPixelColor(i, rightP.Color(255, 255, 255));
    leftP.setPixelColor(i, leftP.Color(255, 255, 255));
  }
  rightP.show();
  leftP.show();
  delay(100);
  for(int i=0; i<NUMPIXELS; i++) { 
    rightP.setPixelColor(i, rightP.Color(255, 255, 255));
    leftP.setPixelColor(i, leftP.Color(255, 255, 255));
  }
  rightP.setBrightness(0);
  leftP.setBrightness(0);
  rightP.show();
  leftP.show();
  delay(500);
}

void dash(){
  rightP.setBrightness(80);
  leftP.setBrightness(80);
  for(int i=0; i<NUMPIXELS; i++) { 
    rightP.setPixelColor(i, rightP.Color(255, 255, 255));
    leftP.setPixelColor(i, leftP.Color(255, 255, 255));
  }
  rightP.show();
  leftP.show();
  delay(1000);
  for(int i=0; i<NUMPIXELS; i++) { 
    rightP.setPixelColor(i, rightP.Color(255, 255, 255));
    leftP.setPixelColor(i, leftP.Color(255, 255, 255));
  }
  rightP.setBrightness(0);
  leftP.setBrightness(0);
  rightP.show();
  leftP.show();
  delay(500);
}

void morse(){
    if (Serial.available()) {
    input = Serial.readString();
    Serial.println(input);
  }
  for( int i = 0; i < sizeof(input); i++){
    if(input[i] == ' '){
      delay(5000);
      Serial.print(" ");
    }
    else if(input[i] == '\n'){
      delay(10000);
      Serial.println("");
    }
    else{
      for( int j = 0; j < 26; j++){
        if(input[i] == key[j][0][0]){
          for( int p = 0; p < key[j][1].length(); p++){
            if( key[j][1][p] == '.'){
              Serial.print(".");
              dot();
            }
            else if( key[j][1][p] == '-'){
              Serial.print("-");
              dash();
            }
          }
        }
      }
    }
  }
}

void lighting(){
  int lightInput = analogRead(A5)/7 - 10;
  Serial.println(lightInput);
  if( lightInput > 50){
      rightP.setBrightness(0);
      leftP.setBrightness(0);
  }
  else{
    if( lightInput < 0){
      lightInput = 0;
    }
    rightP.setBrightness(100 - lightInput);
    leftP.setBrightness(100 - lightInput);
  }
  for(int i=0; i<NUMPIXELS; i++) { 
    rightP.setPixelColor(i, rightP.Color(255, 255, 255));
    leftP.setPixelColor(i, leftP.Color(255, 255, 255));
    rightP.show();   // Send the updated pixel colors to the hardware.
    leftP.show();
  }
}
void normal(){
  rightP.setBrightness(80);
  leftP.setBrightness(80);
    for(int i = 0; i< NUMPIXELS; i++){
          rightP.setPixelColor(i, rightP.Color(0, 0, 255));
          leftP.setPixelColor(i, leftP.Color(0, 0,255));
          rightP.show();   // Send the updated pixel colors to the hardware.
          leftP.show();
  }
}
void rainbow(){
  rightP.setBrightness(80);
  leftP.setBrightness(80);
  for(int i = 0; i< NUMPIXELS; i++){
          rightP.setPixelColor(i, rightP.Color(0, 0, 0));
          leftP.setPixelColor(i, leftP.Color(0, 0, 0));
          rightP.setPixelColor((i+1)%NUMPIXELS, rightP.Color(75, 0, 130));
          leftP.setPixelColor((i+1)%NUMPIXELS, leftP.Color(75, 0, 130));
          rightP.setPixelColor((i+2)%NUMPIXELS, rightP.Color(0, 0, 255));
          leftP.setPixelColor((i+2)%NUMPIXELS, leftP.Color(0, 0, 255));
          rightP.setPixelColor((i+3)%NUMPIXELS, rightP.Color(0, 255, 0));
          leftP.setPixelColor((i+3)%NUMPIXELS, leftP.Color(0, 255, 0));
          rightP.setPixelColor((i+4)%NUMPIXELS, rightP.Color(255, 255, 0));
          leftP.setPixelColor((i+4)%NUMPIXELS, leftP.Color(255, 255,0));
          rightP.setPixelColor((i+5)%NUMPIXELS, rightP.Color(255, 127, 0));
          leftP.setPixelColor((i+5)%NUMPIXELS, leftP.Color(255, 127,0));
          rightP.setPixelColor((i+6)%NUMPIXELS, rightP.Color(255, 0, 0));
          leftP.setPixelColor((i+6)%NUMPIXELS, leftP.Color(255, 0,0));
          rightP.show();   // Send the updated pixel colors to the hardware.
          leftP.show();
          delay(100);
  }
  
}
